require 'amrita2/template'
include Amrita2

t = TemplateText.new("<body><dl><dt /><dd /></dl></body>")
t.spec = Amrita2::define_template_spec do 
  dynamic_element(:l, :matcher=>Amrita2::HtmlTag::DL) do
    dynamic_element(:t, :matcher=>Amrita2::HtmlTag::DT)
    dynamic_element(:d, :matcher=>Amrita2::HtmlTag::DD, :output_stream=>:t)
  end
end

data = [
  [ 'amrita', 'a template library' ],
  [ 'Amrita2', 'a better template library' ],
]

t.expand(STDOUT) do |m|
  m.l do |ml|
    data.each do |t,d|
      ml.t(t)
      ml.d(d)
    end
  end
end

puts

__END__
<body><dl><dt>amrita</dt><dd>a template library</dd><dt>Amrita2</dt><dd>a better template library</dd></dl></body>
