module TodoHelper

   def self.create_parts_template
     doc = REXML::Document.new <<-END
       <div id='parts'>
         <input id='checkbox_on' checked="checked" type="checkbox" value="$1" onclick='document.location.href="$2"' />
         <input id='checkbox_off'  type="checkbox" value="$1" onclick='document.location.href="$2"' />
         <a id='link' href="$2">$1</a> 
         <a id='confirm_link' href="$2" onclick="return confirm('$3');">$1</a> 
       </div>
     END
     spec = Amrita2::define_tempalte_spec do 
       dynamic_element(:parts) do
         parts_element(:checkbox_on, :use_args=>true)
         parts_element(:checkbox_off, :use_args=>true)
         parts_element(:link, :use_args=>true)
         parts_element(:confirm_link, :use_args=>true)
       end
     end
     spec.create_template_module(doc)
   end

  include create_parts_template

  def list_spec
    Amrita2::define_tempalte_spec do 
      dynamic_element(:not_done) do
        dynamic_element(:item_done, :delete_tag=>true)
        dynamic_element(:description, :delete_tag=>true)
        dynamic_element(:edit_link, :delete_tag=>true)
        dynamic_element(:destroy_link, :delete_tag=>true)
      end
      dynamic_element(:done) do
        dynamic_element(:item_done, :delete_tag=>true)
        dynamic_element(:description, :delete_tag=>true)
        dynamic_element(:edit_link, :delete_tag=>true)
        dynamic_element(:destroy_link, :delete_tag=>true)
      end
    end
  end

  def checkbox(v, id)
    if v.to_i != 0
      checkbox_on(v, "/todo/toggle_check/#{id}")
    else
      checkbox_off(v, "/todo/toggle_check/#{id}")
    end
  end

  def display_item(m, item)
    m.description(item.description)
    m.item_done(checkbox(item.done, item.id))
    m.edit_link(link("Edit", "/todo/edit/#{item.id}"))
    msg = "Are you sure you want to delete this entry: #{item.description}"
    m.destroy_link(confirm_link("Destroy", "/todo/destroy/#{item.id}", msg))
  end

  def list_po
    proc do |m|
      controller.not_done.each do |r|
        m.not_done do |mdone|
          display_item(mdone, r)
        end
      end
      controller.done.each do |r|
        m.done do |mdone|
          display_item(mdone, r)
        end
      end
    end
  end
end

