require 'tableview'

include TableView

TABLE_TEMPLATE = <<-END
    <table border='1'>
      <thead>
        <tr><th></th><th></th></tr>
      </thead>
      <tbody>
        <tr><th></th><td></td></tr>
      </tbody>
    </table>
END

Data1 = Struct.new(:a, :b, :c, :d, :e)
data = []
data << Data1.new('A',1,1,1,"A1111")
data << Data1.new('A',1,1,1,"A1112")
data << Data1.new('A',1,1,1,"A1113")
data << Data1.new('B',1,2,2,21)
data << Data1.new('B',2,2,2,22)
data << Data1.new('C',3,3,3,33)
data << Data1.new('D',3,2,1,4321)
data << Data1.new('D',1,4,1,4141)
data << Data1.new('E',2,5,5,251)
data << Data1.new('E',5,5,5,51)
data << Data1.new('E',5,5,5,52)

v = ViewSetting.new {
  row(:a)
  column(:b)
  url do |d|
    "http://xxx.walrus-ruby.org/somedata/#{d.c}/#{d.e}"
  end
  short_display do |d|
    "#{d.d}:#{d.e}"
  end
}

items = data.collect { |d| v.create_item(d)} 
pd = PageData.new(items)

doc = REXML::Document.new  TABLE_TEMPLATE
table_template = TableView::TABLE_SPEC.create_template(doc)

table_template.expand_template(STDOUT) do |m|
  pd.format(m) do |items|
    items.collect do |i| 
      i.short_display
    end.join("\n")
  end
end

# change item format

ITEM_TEMPLATE = <<-END
<ul>
  <li> <a href=""></a></li>
</ul>
END

ITEM_SPEC = Amrita2::define_template_spec do 
  dynamic_element(:li, :matcher=>TagMatcher.new(:li)) do
    dynamic_element(:data,  
                    :matcher=>TagMatcher.new(:a),
                    :replace_attr=>true) 
  end
end
      
item_doc = REXML::Document.new  ITEM_TEMPLATE
#item_module = ITEM_SPEC.create_template_module(item_doc)
item_format = ITEM_SPEC.create_template(item_doc)

# change view


v = ViewSetting.new {
  row(:b)
  column(:a)
  url do |d|
    "http://xxx.walrus-ruby.org/somedata/#{d.c}/#{d.e}"
  end
  long_display do |d|
    "#{d.c}:#{d.d}:#{d.e}"
  end
}

items = data.collect { |d| v.create_item(d)} 
pd = PageData.new(items)

table_template.expand_template(STDOUT) do |m|
  pd.format(m) do |items|
    item_format.expand_template(ret="") do |mi|
      items.each do |item| 
        mi.li do |ma|
          ma.data(item.long_display, :href=>item.url)
        end
      end
    end
    Amrita2::SanitizedString[ret]
  end
end

# table_template.expand_template(STDOUT) do |m|
#   pd.format(m) do |items|
#     items.each do |item| 
#       item_module::MainContext::li do |ma|
#         ma.data(item.long_display, :href=>item.url)
#       end
#     end
#     ""
#   end
# end
